<?php
// invite main page
$page['header'] = LBL_INVITE;
$page['javascript'] = "<script src='javascript/invite.js' type='text/javascript'></script>\n";
$page['content'] = '';

//$page['content'] .= "<pre>" . print_r($_POST, true) . "</pre>\n";

$group_id = $_POST['group_id'];
$control = $_POST['control'];
$mail_addresses = $_POST['mail_addresses'];
$subject = $_POST['subject'];
$body = $_POST['body'];

if ($control == LBL_INVITE_FORM_ACTION && !$_FILES['csvfile']['error']) {
  $page['messages'][] .= MESSAGE_UPLOAD_OK;
  $mail_addresses = implode(",", file($_FILES['csvfile']['tmp_name'], FILE_IGNORE_NEW_LINES));
}

$gr = new_grouper();
if (!$gr->isConnected()) {
  $page['errors'][] = ERROR_GROUPER_CONNECT;
  return;
}

$group = $gr->getGroup($group_id);

if ($control == LBL_INVITE_FORM_ACTION && !$mail_addresses) {
  $page['errors'][] = LBL_INVITE_NOMAILADDRESSES;
  unset($control);
}

if (!$control) {
  if (!$subject) $subject = sprintf(LBL_INVITE_DEFAULT_SUBJECT, $group['name']);
  if (!$body) $body = sprintf(LBL_INVITE_DEFAULT_BODY,  $attributes[$as['attributes'][LBL_AS_GIVENNAME]][0] . " " .  $attributes[$as['attributes'][LBL_AS_SURNAME]][0], $group['name']);
  $page['content'] .= "<h2>" . $group['name'] . "</h2>\n";
  $page['content'] .= LBL_INVITE_CONTENT . "<br><br>\n";
  $page['content'] .= "<form method='post' enctype='multipart/form-data'>\n";
  $page['content'] .= "<input type=hidden name=MAX_FILE_SIZE value=100000>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $group_id . "'>\n";
  $page['content'] .= LBL_INVITE_EMAILADDRESS . "\n";
  $page['content'] .= "<span id='no_csv' style='display: inline'><a href=\"#\" onclick='toggle_csv(1); return false;'>" . LBL_INVITE_IMPORT . "</a><br>\n";
  $page['content'] .= "<input type=text name='mail_addresses' size='81' value='" . $mail_addresses . "'></span>\n";
  $page['content'] .= "<span id='csv' style='display: none'><a href=\"#\" onclick='toggle_csv(0); return false;'>" . LBL_INVITE_NORMAL . "</a><br>\n";
  $page['content'] .= "<input name='csvfile' type='file' size='53'></span>\n";
  $page['content'] .= "<br><br>\n";
  $page['content'] .= LBL_INVITE_SUBJECT . "<br>\n";
  $page['content'] .= "<input type=text name='subject' size='81' value='" . htmlspecialchars(stripslashes($subject), ENT_QUOTES) . "'><br><br>\n";
  $page['content'] .= LBL_INVITE_BODY . "<br>\n";
  $page['content'] .= "<textarea name='body' cols='80' rows='10'>" . htmlspecialchars(stripslashes($body), ENT_QUOTES) . "</textarea><br><br>\n";
  $page['content'] .= "<input type='submit' name='control' value='" . LBL_INVITE_FORM_ACTION . "'>\n";
  $page['content'] .= "</form>\n";

} else if ($control == LBL_INVITE_FORM_ACTION)  {
  $page['content'] .= LBL_INVITE_SUCCESS;
  $page['content'] .= "<br><br>\n";

  if (!db_connect($db)) {
    $page['errors'][] = ERROR_DB_CONNECT;
    return;
  }

  //$page['messages'][] = MESSAGE_DB_CONNECT;

  $mail_array = explode(",", $mail_addresses);
  foreach ($mail_array as $address) {
    if (!$address = trim(stripslashes($address))) continue;
    if (!valid_address($address)) {
      $page['content'] .= LBL_INVITE_INVALID_ADDRESS . ": $address<br><br>\n";
      continue;
    }
    if ($uiid = set_invitation($db, $group_id, $address, $uuid)) {
      $page['content'] .= LBL_INVITE_EMAILADDRESS . " $address<br>\n";

      $https = $_SERVER['HTTPS'];
      $host = $_SERVER['SERVER_NAME'];
      $url = ($https ? "https" : "http") . "://$host/process";
      $accept_url = $url . "?accept=$uiid";
      $deny_url = $url . "?deny=$uiid";

      $message = $body . "\n\n" . sprintf(LBL_INVITE_BODY_FOOTER, $accept_url, $deny_url);
      if (!mail($address, stripslashes($subject), stripslashes($message), "From: systeembericht@surfteams.nl\r\nReply-To: systeembericht@surfteams.nl")) {
	$page['errors'][] = ERROR_SEND_INVITATION;
	break;
      }
    } else {
      $page['errors'][] = ERROR_CREATE_INVITATION;
      break;
    }
  }

  $page['content'] .= "<br><br>\n";
  $page['content'] .= "<form method='post' action='members'>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $group_id . "'>\n";
  $page['content'] .= "<input type='submit' name='control' value='" . LBL_INVITE_RETURN . "'>\n";
  $page['content'] .= "</form>\n";

}

?>